﻿@using Services;
@inject ConvertService convertService

<div>
    <EditForm Model="@DummyModel">
        <div class="form-group">
            <h6>Salary = Lots of stuff</h6>
        </div>
        <div class="form-group">
            <table class="table table-hover table-sm">
                <tbody>
                    <tr>
                        <td><b>Timings</b></td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>Days in a week : @DayInWeek</td>
                        <td>
                            <input type="range" class="form-range" min="1" max="7" step="1" value="@DayInWeek" @oninput="__e => DayInWeek = Convert.ToInt32(__e?.Value ?? 7)">
                        </td>
                    </tr>
                    <tr>
                        <td>Days in a month : @DayInMonth</td>
                        <td>
                            <input type="range" class="form-range" min="1" max="31" step="1" value="@DayInMonth" @oninput="__e => DayInMonth = Convert.ToInt32(__e?.Value ?? 28)">
                        </td>
                    </tr>
                    <tr>
                        <td>Hours in a day : @HourInDay</td>
                        <td>
                            <input type="range" class="form-range" min="1" max="23" step="1" value="@HourInDay" @oninput="__e => HourInDay = Convert.ToInt32(__e?.Value ?? 8)">
                        </td>
                    </tr>
                    <tr>
                        <td><b>Amount</b></td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>Per year</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optAmountSelection" value="@AmountSelection.PerYear" checked="@((AmountSelectType == AmountSelection.PerYear))" @onchange="__e => AmountSelectType = AmountSelection.PerYear" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@AmountPerYear" @oninput="((ChangeEventArgs __e) => AmountPerYear = ToDouble(__e?.Value))" disabled="@(!(AmountSelectType == AmountSelection.PerYear))" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Per month</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optAmountSelection" value="@AmountSelection.PerMonth" checked="@((AmountSelectType == AmountSelection.PerMonth))" @onchange="__e => AmountSelectType = AmountSelection.PerMonth" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@AmountPerMonth" @oninput="((ChangeEventArgs __e) => AmountPerMonth = ToDouble(__e?.Value))" disabled="@(!(AmountSelectType == AmountSelection.PerMonth))" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Per week</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optAmountSelection" value="@AmountSelection.PerWeek" checked="@((AmountSelectType == AmountSelection.PerWeek))" @onchange="__e => AmountSelectType = AmountSelection.PerWeek" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@AmountPerWeek" @oninput="((ChangeEventArgs __e) => AmountPerWeek = ToDouble(__e?.Value))" disabled="@(!(AmountSelectType == AmountSelection.PerWeek))" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Per day</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optAmountSelection" value="@AmountSelection.PerDay" checked="@((AmountSelectType == AmountSelection.PerDay))" @onchange="__e => AmountSelectType = AmountSelection.PerDay" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@AmountPerDay" @oninput="((ChangeEventArgs __e) => AmountPerDay = ToDouble(__e?.Value))" disabled="@(!(AmountSelectType == AmountSelection.PerDay))" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Per hour</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optAmountSelection" value="@AmountSelection.PerHour" checked="@((AmountSelectType == AmountSelection.PerHour))" @onchange="__e => AmountSelectType = AmountSelection.PerHour" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@AmountPerHour" @oninput="((ChangeEventArgs __e) => AmountPerHour = ToDouble(__e?.Value))" disabled="@(!(AmountSelectType == AmountSelection.PerHour))" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td><b>Variable Pay</b></td>
                        <td></td>
                    </tr>
                    <tr>
                        <td>Per Year</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optVariableSelection" value="@VariableSelection.PerYear" checked="@((VariableSelectType == VariableSelection.PerYear))" @onchange="__e => VariableSelectType = VariableSelection.PerYear" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@VariablePerYear" @oninput="((ChangeEventArgs __e) => VariablePerYear = ToDouble(__e?.Value))" disabled="@(!(VariableSelectType == VariableSelection.PerYear))" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Per Month</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optVariableSelection" value="@VariableSelection.PerMonth" checked="@((VariableSelectType == VariableSelection.PerMonth))" @onchange="__e => VariableSelectType = VariableSelection.PerMonth" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@VariablePerMonth" @oninput="((ChangeEventArgs __e) => VariablePerMonth = ToDouble(__e?.Value))" disabled="@(!(VariableSelectType == VariableSelection.PerMonth))" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Percentage</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optVariableSelection" value="@VariableSelection.Percentage" checked="@((VariableSelectType == VariableSelection.Percentage))" @onchange="__e => VariableSelectType = VariableSelection.Percentage" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@VariablePercentage" @oninput="((ChangeEventArgs __e) => VariablePercentage = ToDouble(__e?.Value))" disabled="@(!(VariableSelectType == VariableSelection.Percentage))" maxlength="6" />
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </EditForm>
</div>

@code {

    private string DummyModel { get; set; } = string.Empty;

    private const int MonthInYear = 12;
    private int DayInWeek { get; set; } = 7;
    private int DayInMonth { get; set; } = 28;
    private int HourInDay { get; set; } = 8;

    private enum AmountSelection { PerYear, PerMonth, PerWeek, PerDay, PerHour };

    private AmountSelection AmountSelectType { get; set; } = AmountSelection.PerMonth;
    private double AmountPerYear { get; set; } = 0;
    private double AmountPerMonth { get; set; } = 0;
    private double AmountPerWeek { get; set; } = 0;
    private double AmountPerDay { get; set; } = 0;
    private double AmountPerHour { get; set; } = 0;

    private enum VariableSelection { PerYear, PerMonth, Percentage };

    private VariableSelection VariableSelectType { get; set; } = VariableSelection.PerMonth;
    private double VariablePerYear { get; set; } = 0;
    private double VariablePerMonth { get; set; } = 0;
    private double VariablePercentage { get; set; } = 0;

    protected override bool ShouldRender()
    {
        RefreshValues();
        bool shouldRender = base.ShouldRender();
        return shouldRender;
    }

    private double ToDouble(object value) => convertService.ToDouble(value);

    private void RefreshValues()
    {
        CalculateAmount();
        CalculateVariableValues();
    }

    private void ClearAmount()
    {
        AmountPerYear = 0;
        AmountPerMonth = 0;
        AmountPerWeek = 0;
        AmountPerDay = 0;
        AmountPerHour = 0;
    }

    private void ClearVariableValues()
    {
        VariablePerMonth = 0;
        VariablePerMonth = 0;
        VariablePercentage = 0;
    }

    private void CalculateAmount()
    {
        switch (AmountSelectType)
        {
            case AmountSelection.PerYear:
                if (AmountPerYear > 0)
                {
                    AmountPerMonth = Math.Round(AmountPerYear / MonthInYear, 2);
                    AmountPerWeek = Math.Round(AmountPerMonth / DayInWeek, 2);
                    AmountPerDay = Math.Round(AmountPerMonth / DayInMonth, 2);
                    AmountPerHour = Math.Round(AmountPerDay / HourInDay, 2);
                }
                else ClearAmount();
                break;
            case AmountSelection.PerMonth:
                if (AmountPerMonth > 0)
                {
                    AmountPerYear = AmountPerMonth * MonthInYear;
                    AmountPerWeek = Math.Round(AmountPerMonth / DayInWeek, 2);
                    AmountPerDay = Math.Round(AmountPerMonth / DayInMonth, 2);
                    AmountPerHour = Math.Round(AmountPerDay / HourInDay, 2);
                }
                else ClearAmount();
                break;
            case AmountSelection.PerWeek:
                if (AmountPerWeek > 0)
                {
                    AmountPerDay = Math.Round(AmountPerWeek / DayInWeek, 2);
                    AmountPerMonth = AmountPerDay * DayInMonth;
                    AmountPerYear = AmountPerMonth * MonthInYear;
                    AmountPerHour = Math.Round(AmountPerDay / HourInDay, 2);
                }
                else ClearAmount();
                break;
            case AmountSelection.PerDay:
                if (AmountPerDay > 0)
                {

                    AmountPerWeek = AmountPerDay * DayInWeek;
                    AmountPerMonth = AmountPerDay * DayInMonth;
                    AmountPerYear = AmountPerMonth * MonthInYear;
                    AmountPerHour = Math.Round(AmountPerDay / HourInDay, 2);
                }
                else ClearAmount();
                break;
            case AmountSelection.PerHour:
                if (AmountPerHour > 0)
                {
                    AmountPerDay = AmountPerHour * HourInDay;
                    AmountPerWeek = AmountPerDay * DayInWeek;
                    AmountPerMonth = AmountPerDay * DayInMonth;
                    AmountPerYear = AmountPerMonth * MonthInYear;
                }
                else ClearAmount();
                break;
            default:
                throw new NotImplementedException();
        }
    }

    private void CalculateVariableValues()
    {
        switch (VariableSelectType)
        {
            case VariableSelection.PerYear:
                if (VariablePerYear > 0)
                {
                    VariablePerMonth = Math.Round(VariablePerYear / MonthInYear, 2);
                    VariablePercentage = Math.Round(VariablePerYear / AmountPerYear * 100, 2);
                }
                else ClearVariableValues();
                break;
            case VariableSelection.PerMonth:
                if (VariablePerMonth > 0)
                {
                    VariablePerYear = VariablePerMonth * MonthInYear;
                    VariablePercentage = Math.Round(VariablePerYear / AmountPerYear * 100, 2);
                }
                else ClearVariableValues();
                break;
            case VariableSelection.Percentage:
                if (VariablePercentage > 0)
                {
                    VariablePerYear = (AmountPerYear * VariablePercentage) / 100;
                    VariablePerMonth = (AmountPerMonth * VariablePercentage) / 100;
                }
                else ClearVariableValues();
                break;
            default:
                throw new NotImplementedException();
        }
    }

}
